#include <WScom.h>
#include <WSCfunctionList.h>
#include <WSCbase.h>
//----------------------------------------------------------
//Function for the event procedure
//----------------------------------------------------------
#include <WSCvmeter.h>
#include <WSCvfbtn.h>
#include <WSDtimer.h>
#include <WSCoption.h>


extern WSCvfbtn *newvfbt_000;
extern WSCvmeter *newvmet_001;
extern WSCoption *newopti_s10;
extern WSCoption *newopti_s01;
extern WSCoption *newopti_m10;
extern WSCoption *newopti_m01;

static int ontimer = 0, timerid;


int getSecond(){

  return 
    (((int)newopti_m10->getProperty(WSNvalue)-1) * 10 +
     ((int)newopti_m01->getProperty(WSNvalue)-1)) * 60 +
    (((int)newopti_s10->getProperty(WSNvalue)-1) * 10 +
     ((int)newopti_s01->getProperty(WSNvalue)-1));
}


void timer_proc(WSCuchar clock, void* data){

  if(ontimer == 0) return;

  int goalsec = getSecond();
  
  if(goalsec == 0){
    WSGIappTimer()->delTimerProc(timerid);
    ontimer = 0;
    return;
  }


  int pastsec = newvmet_001->getProperty(WSNuserValue);
  pastsec = (pastsec + 1) % goalsec;
  newvmet_001->setProperty(WSNuserValue, pastsec);


  newvmet_001->setProperty(WSNvalue1, pastsec * 100 / goalsec);


  WSCstring str;
  str << "past " << pastsec / 60 << "'" << pastsec % 60 << "\" : "
      << "last " << (goalsec - pastsec) / 60 << "'"
      << (goalsec - pastsec) % 60 << "\" : "
      << "end  " << goalsec / 60 << "'" << goalsec % 60 << "\"";
  newvfbt_000->setProperty(WSNlabelString, str);

  newvfbt_000->update();
  newvmet_001->update();
}


void time(WSCbase* object){

  if(ontimer == 1){
    WSGIappTimer()->delTimerProc(timerid);
    ontimer = 0;
  }else{
    timerid = WSGIappTimer()->addTimerProc(timer_proc, WS1000MS, NULL);
    ontimer = 1;
  }

}

static WSCfunctionRegister  op("time",(void*)time);
